package com.liang.dao;

import com.liang.entity.PrjFeescheme;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * 出资方案(PrjFeescheme)表数据库访问层
 *
 * @author makejava
 * @since 2023-04-09 13:54:37
 */
public interface PrjFeeschemeDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjFeescheme queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param prjFeescheme 查询条件
     * @param pageable     分页对象
     * @return 对象列表
     */
    List<PrjFeescheme> queryAllByLimit(PrjFeescheme prjFeescheme, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjFeescheme 查询条件
     * @return 总行数
     */
    long count(PrjFeescheme prjFeescheme);

    /**
     * 新增数据
     *
     * @param prjFeescheme 实例对象
     * @return 影响行数
     */
    int insert(PrjFeescheme prjFeescheme);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjFeescheme> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjFeescheme> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjFeescheme> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjFeescheme> entities);

    /**
     * 修改数据
     *
     * @param prjFeescheme 实例对象
     * @return 影响行数
     */
    int update(PrjFeescheme prjFeescheme);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 删除项目出资方案
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 批量删除出资方案
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 批量删除出资方案
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    /**
     * 获取出资方案列表
     *
     * @return
     */
    List<PrjFeescheme> getFeeSchemeList(Map map);

    /**
     * 获取年度出资总金额
     *
     * @return
     */
    Double getNdFeeScheme(Map map);

    /**
     * 获取年份列表
     *
     * @return
     */
    List<Integer> getYearList(Integer zb);

    double queryByCzje(double czje);

    Double getNdFeeSchemeofDKY(Map map);
}

